=== debian/changelog ===
geographiclib (1.37-3ubuntu1) vivid; urgency=medium

  * Fix symbols for ppc64el to fix FTBFS (LP: #1426676)

 -- Ross Gammon <rossgammon@mail.dk>  Sat, 28 Feb 2015 11:32:28 +0100

geographiclib (1.37-3) unstable; urgency=medium

  * Add Conflicts/Replace to libgeographic-dev (Closes: #768216)

 -- Ross Gammon <rossgammon@mail.dk>  Thu, 06 Nov 2014 18:25:05 +0100

geographiclib (1.37-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbols file for mips64(el) and ppc64el (Closes: #766984).

 -- YunQiang Su <syq@debian.org>  Mon, 03 Nov 2014 09:15:36 +0000

geographiclib (1.37-2) unstable; urgency=medium

  * Update symbols file to fix FTBFS on 32 bit arches (Closes: #762485)

 -- Ross Gammon <rossgammon@mail.dk>  Mon, 29 Sep 2014 21:31:55 +0200

geographiclib (1.37-1) unstable; urgency=medium

  * Imported Upstream version 1.37
  * Use dh-autoreconf to fix FTBFS on ppc64el.
    Thanks to Logan Rosen (Closes: #735004)
  * Fix lintian error with Short Description
  * Remove duplicate license information
  * Ignore quilt .pc files
  * Drop datadir patch and create datadir path with debian/dirs file instead
  * Add myself to uploaders and tidy control file
  * Install RhumbSolve tool binary
  * SONAME bump
  * Install python files according to latest Python Library Style Guide
  * Add myself to debian/copyright
  * Remove dh_make comments from watch file to fix lintian informational
  * Rename lib & dev packages to avoid lintian warning
  * Resolved privacy breaches
  * Correct datadir path in datasets download script
  * Bump policy to 3.9.6. No changes required.
  * Add autoconf-archive dependency

 -- Ross Gammon <rossgammon@mail.dk>  Thu, 28 Aug 2014 22:16:20 +0200
