=== debian/rules ===
#!/usr/bin/make -f
export PYBUILD_NAME=geographiclib
export PYBUILD_SYSTEM=pybuild

%:
	dh $@ --with autoreconf,python2

#override_dh_auto_configure:
#	dh_auto_configure --  --datadir=/usr/share/geographiclib --prefix=/usr

override_dh_install:
	# Remove duplicate license information
	rm debian/tmp/usr/share/doc/geographiclib/html/LICENSE.txt
	dh_install --list-missing
