=== debian/watch ===
version=3

http://sf.net/geographiclib/[gG]eographic[lL]ib-(.*)\.tar\.gz
